*-- Page Printer Form Generator with Data Fill-In
*-- by HazMatZak @ ATBBS 213-538-6196 (1200-8-N-1)
*-- for dBASE IV v1.1   12/19/90   v1.01

*-- Specific printer codes for HP LaserJet II
*-- with IQ Engineering SuperCartridge 2.
*-- Uses Times 10, Letter Gothic 12 (Roman-8 symbol set)
*-- and special symbols from Math-8 and Helv Pi symbols sets.
*-- If you don't have these, substitute!


do prnsetup                     && init memvars

*-- Setup
??? prnctrl (p_reset, "")       && reset printer
??? prnctrl (p_port, "")        && portrait
??? prnctrl (p_sym, "8U")       && Roman-8 primary symbol set
??? prnctrl (p_sym2, "8U")      && and secondary symbol set
??? prnctrl (p_tmarg, 0)        && top margin 0

*-- Outside box, 1/2 inch all around, 7 1/2 x 10 inside
??? prnctrl (p_rhdot, 2270)     && 2270 dots wide
??? prnctrl (p_rvdot, 10)       && 10 dots tall
??? prnctrl (p_rscale, 100)     && 100% grey (black)
??? prnctrl (p_hdot, 90)        && starting from 90 dots left
??? prnctrl (p_vdot, 140)       && 140 dots down
??? prnctrl (p_rgrey, "")       && print the rule (top)
??? prnctrl (p_vdot, 3150)      && starting 3150 dots down
??? prnctrl (p_rgrey, "")       && print the rule (bottom)
??? prnctrl (p_rhdot, 10)
??? prnctrl (p_rvdot, 3020)
??? prnctrl (p_vdot, 140)
??? prnctrl (p_rgrey, "")
??? prnctrl (p_hdot, 2350)
??? prnctrl (p_rgrey, "")

*-- Fonts
*-- Setup primary font for form legends (e.g. Name, Address)
*-- and secondary font for form data
*-- and use shift function to switch back and forth
??? prnctrl (p_propor, "")      && primary is proportional
??? prnctrl (p_point, 10)       && 10-point
??? prnctrl (p_upright, "")     && upright (not italic)
??? prnctrl (p_med, "")         && medium (not bold)
??? prnctrl (p_times, "")       && Times
??? prnctrl (p_fixed2, "")      && secondary is fixed
??? prnctrl (p_pitch2, 12)      && 12-cpi
??? prnctrl (p_point2, 12)      && 12-point
??? prnctrl (p_upright2, "")
??? prnctrl (p_med2, "")
??? prnctrl (p_gothic2, "")     && Letter Gothic

*-- Fake data
name = "Joe D. Shmoe"
address = "123 Main St."

??? legend (1, 250, "Name")
??? datum (1, 250, name)

??? legend (2, 250, "Address")
??? datum (2, 250, address)

*-- Highlights (grey shading)
??? prnctrl (p_rscale, 5)       && 5% grey
??? prnctrl (p_rvdot, 100)      && 100 dots tall
??? g_highl (1, 250, 900)       && row 1, 250 dots left, 900 wide

*-- Reset
??? prnctrl (p_reset, "")       && reset printer will eject page

do prnshtdn                     && release memvars

return                          && end MAIN

****************************************

function prnctrl
  *-- Returns printer control codes
  parameters prn_func, prn_arg
  *-- prn_func = printer function memvar name
  *-- prn_arg  = function argument, or null string for none
  private fval
  do case
    *-- p_numarg = function argument placeholder
    *--            (see specific printer setup procedure)
    case p_numarg $ prn_func
      fval = stuff (prn_func, at (p_numarg, prn_func), 1, ;
        iif (type ("prn_arg") = "N", ltrim (str (prn_arg)), prn_arg))
    *-- Undefined printer function
    case "" = prn_func
      fval = ""
    otherwise
      fval = prn_func + prn_arg
  endcase
return fval

procedure prnsetup
  *-- printer function memvars
  public ;
    p_numarg, ;
    p_tmarg, ;
    p_txtlen, ;
    p_lmarg, ;
    p_rmarg, ;
    p_hmi, ;
    p_vmi, ;
    p_vrow, ;
    p_vdot, ;
    p_vdcpt, ;
    p_hcol, ;
    p_hdot, ;
    p_hdcpt, ;
    p_port, ;
    p_land, ;
    p_sym, ;
    p_propor, ;
    p_fixed, ;
    p_pitch, ;
    p_point, ;
    p_upright, ;
    p_italic, ;
    p_light, ;
    p_med, ;
    p_bold, ;
    p_lp, ;
    p_pica, ;
    p_elite, ;
    p_courier, ;
    p_helv, ;
    p_times, ;
    p_gothic, ;
    p_script, ;
    p_prestige, ;
    p_sym2, ;
    p_propor2, ;
    p_fixed2, ;
    p_pitch2, ;
    p_point2, ;
    p_upright2, ;
    p_italic2, ;
    p_light2, ;
    p_med2, ;
    p_bold2, ;
    p_lp2, ;
    p_pica2, ;
    p_elite2, ;
    p_courier2, ;
    p_helv2, ;
    p_times2, ;
    p_gothic2, ;
    p_script2, ;
    p_prestig2, ;
    p_shift2, ;
    p_shift1, ;
    p_rhdot, ;
    p_rhdcpt, ;
    p_rvdot, ;
    p_rvdcpt, ;
    p_rscale, ;
    p_rgrey, ;
    p_rend, ;
    p_reset, ;
    p_undon, ;
    p_undoff, ;
    p_perfoff, ;
    p_perfon
  *-- special symbols
  public bullet12, bubble, bullet10, fbox, ebox
  public chr_micro, chr_check, x_mark, checkmark

  *-- specific printer setups for memvars
  do case
    case lower (_pdriver) = "hp"
      do p_hplj2sc
  endcase

return

procedure p_hplj2sc
  *-- Printer setup for HP LaserJet II with IQE SuperCartridge 2
  esc = chr (27)
  p_numarg = "#"                && argument placeholder
  p_tmarg = esc + "&l#E"
  p_txtlen = esc + "&l#F"
  p_lmarg = esc + "&a#L"
  p_rmarg = esc + "&a#M"
  p_hmi = esc + "&k#H"
  p_vmi = esc + "&l#C"
  p_vrow = esc + "&a#R"
  p_vdot = esc + "*p#Y"         && 300 dots per inch
  p_vdcpt = esc + "&a#V"        && 720 decipoints per inch
  p_hcol = esc + "&a#C"
  p_hdot = esc + "*p#X"
  p_hdcpt = esc + "&a#H"
  p_port = esc + "&l0O"
  p_land = esc + "&l1O"
  p_sym = esc + "("
  p_propor = esc + "(s1P"
  p_fixed = esc + "(s0P"
  p_pitch = esc + "(s#H"
  p_point = esc + "(s#V"
  p_upright = esc + "(s0S"
  p_italic = esc + "(s1S"
  p_light = esc + "(s-3B"
  p_med = esc + "(s0B"
  p_bold = esc + "(s3B"
  p_lp = esc + "(s0T"
  p_pica = esc + "(s6T"
  p_elite = esc + "(s8T"
  p_courier = esc + "(s3T"
  p_helv = esc + "(s4T"
  p_times = esc + "(s5T"
  p_gothic = esc + "(s6T"
  p_script = esc + "(s20T"
  p_prestige = esc + "(s8T"
  p_sym2 = esc + ")"
  p_propor2 = esc + ")s1P"
  p_fixed2 = esc + ")s0P"
  p_pitch2 = esc + ")s#H"
  p_point2 = esc + ")s#V"
  p_upright2 = esc + ")s0S"
  p_italic2 = esc + ")s1S"
  p_light2 = esc + ")s-3B"
  p_med2 = esc + ")s0B"
  p_bold2 = esc + ")s3B"
  p_lp2 = esc + ")s0T"
  p_pica2 = esc + ")s6T"
  p_elite2 = esc + ")s8T"
  p_courier2 = esc + ")s3T"
  p_helv2 = esc + ")s4T"
  p_times2 = esc + ")s5T"
  p_gothic2 = esc + ")s6T"
  p_script2 = esc + ")s20T"
  p_prestig2 = esc + ")s8T"
  p_shift2 = chr (14)
  p_shift1 = chr (15)
  *-- Rules (i.e. lines, shaded rectangles)
  p_rhdot = esc + "*c#A"
  p_rhdcpt = esc + "*c#H"
  p_rvdot = esc + "*c#B"
  p_rvdcpt = esc + "*c#V"
  p_rscale = esc + "*c#G"
  p_rgrey = esc + "*c2P"
  p_rend = esc + "*rB"
  p_reset = esc + "E"
  p_undon = esc + "&dD"
  p_undoff = esc + "&d@"
  p_perfoff = esc + "&l0L"
  p_perfon = esc + "&l1L"
  *-- Special symbols
  bullet12 = prnctrl (p_sym2, "15U") + prnctrl (p_vdcpt, "+70") + ;
    chr (102) + prnctrl (p_vdcpt, "-70") + prnctrl (p_sym2, "8U")
  bubble = prnctrl (p_sym2, "8M") + chr (205) + prnctrl (p_sym2, "8U")
  bullet10 = prnctrl (p_sym2, "15U") + prnctrl (p_vdcpt, "+40") + ;
    chr (100) + prnctrl (p_vdcpt, "-40") + prnctrl (p_sym2, "8U")
  ebox = prnctrl (p_sym2, "8M") + chr (156) + prnctrl (p_sym2, "8U")
  fbox = prnctrl (p_sym2, "8M") + chr (158) + prnctrl (p_sym2, "8U")
  chr_micro = prnctrl (p_sym2, "8M") + chr (108) + ;
    prnctrl (p_sym2, "8U")
  chr_check = prnctrl (p_sym2, "8M") + chr (33) + ;
    prnctrl (p_sym2, "8U")
  x_mark = prnctrl (p_sym2, "8M") + chr (42) + prnctrl (p_sym2, "8U")
  checkmark = chr (251)
return

procedure prnshtdn
  *-- release all printer memvars
  release ;
    p_numarg, ;
    p_tmarg, ;
    p_txtlen, ;
    p_lmarg, ;
    p_rmarg, ;
    p_hmi, ;
    p_vmi, ;
    p_vrow, ;
    p_vdot, ;
    p_vdcpt, ;
    p_hcol, ;
    p_hdot, ;
    p_hdcpt, ;
    p_port, ;
    p_land, ;
    p_sym, ;
    p_propor, ;
    p_fixed, ;
    p_pitch, ;
    p_point, ;
    p_upright, ;
    p_italic, ;
    p_light, ;
    p_med, ;
    p_bold, ;
    p_lp, ;
    p_pica, ;
    p_elite, ;
    p_courier, ;
    p_helv, ;
    p_times, ;
    p_gothic, ;
    p_script, ;
    p_prestige, ;
    p_sym2, ;
    p_propor2, ;
    p_fixed2, ;
    p_pitch2, ;
    p_point2, ;
    p_upright2, ;
    p_italic2, ;
    p_light2, ;
    p_med2, ;
    p_bold2, ;
    p_lp2, ;
    p_pica2, ;
    p_elite2, ;
    p_courier2, ;
    p_helv2, ;
    p_times2, ;
    p_gothic2, ;
    p_script2, ;
    p_prestig2, ;
    p_shift2, ;
    p_shift1, ;
    p_rhdot, ;
    p_rhdcpt, ;
    p_rvdot, ;
    p_rvdcpt, ;
    p_rscale, ;
    p_rgrey, ;
    p_rend, ;
    p_reset, ;
    p_undon, ;
    p_undoff, ;
    p_perfoff, ;
    p_perfon
  release bullet12, bubble, bullet10, fbox, ebox
  release chr_micro, chr_check, x_mark, checkmark
return

****************************************
* The LaserJet II has a 60 dot (= 144 decipoint = 1/5 inch)
* unprintable area at the top and bottom.  You can print there,
* but nothing will show up.
*
* There is a 50 dot (= 120 decipoint = 1/6 inch) logical left
* margin and a 100 dot (= 240 decipoint = 1/3 inch) logical right
* margin.  All horizontal references are relative to these logical
* margins.  For example, to print at 1 inch from the left edge of
* the paper, you have to specify 250 (300 - 50) dots.
*
* In designing the form, the height of each row has been determined
* to be 240 decipoints (= 100 dots = 1/3 inch).  Using decipoints
* makes it easier to work with text, which are in points.
*
* Each row looks like              as in
*  ---------------------------      ---------------------------
* | Legend                         | Name
* | Data                           | Joe D. Shmoe
*  ---------------------------      ---------------------------
*
* 10-point text has been selected for the legends and 12-point
* for the data.  Since vertical text postions are baseline
* positions, legends are printed 9 points from the top of the
* row, and data is 21 points from the top.
*

function legend
  *-- Print legends
  parameters vl_arg, hd_arg, arg1
  *-- vl_arg = line/row #
  *-- hd_arg = # of dots horizontal
  *-- arg1   = text to print
return prnctrl (p_vdcpt, vl_arg * 240 + 210) + ;
  prnctrl (p_hdot, hd_arg) + arg1

function datum
  *-- Print data with shift in/out codes
  parameters vl_arg, hd_arg, arg1
  *-- vl_arg = line/row #
  *-- hd_arg = # of dots horizontal
  *-- arg1   = text to print
return prnctrl (p_vdcpt, vl_arg * 240 + 330) + ;
  prnctrl (p_hdot, hd_arg) + ;
  prnctrl (p_shift2, "") + arg1 + prnctrl (p_shift1, "")

function g_highl
  parameters vl_arg, hd_arg, arg1
  *-- vl_arg = line/row #
  *-- hd_arg = # of dots horizontal
  *-- arg1   = dot width of grey highlight
return prnctrl (p_vdot, vl_arg * 100 + 50) + ;
  prnctrl (p_hdot, hd_arg) + prnctrl (p_rhdot, arg1) + ;
  prnctrl (p_rgrey, "")

